from turtle import *

def joonista_puu(tyve_pikkus, min_pikkus=10, koef=0.6):
    """
    Joonistab rekursiivselt puu tüve_pikkusega.
    Kui tyve_pikkus > min_pikkus, siis joonistame ka kaks haru:
    alampuud tüve pikkusega tyve_pikkus*koef
    koef on vahemikus 0...1
    """
    assert 0.0 <= koef < 1.0

    if tyve_pikkus > min_pikkus:
        # Joonista tüvi
        forward(tyve_pikkus)
        uus_pikkus = tyve_pikkus * koef
        # Joonista alampuu 1
        left(30)
        joonista_puu(uus_pikkus, min_pikkus, koef)
        # Joonista alampuu 2
        right(60)
        joonista_puu(uus_pikkus, min_pikkus, koef)
        # Taasta tsüklieelne positsioon
        left(30)
        # Taasta algne positsioon
        back(tyve_pikkus)
    else:
        # Joonista leht
        right(90)
        circle(tyve_pikkus/2)
        # Taasta algne positsioon
        left(90)


left(90)
speed(0)
joonista_puu(100, koef=0.8)
